/* worker_locale.cc
 * This file belongs to Worker, a filemanager for UNIX/X11.
 * Copyright (C) 2001-2004 Ralf Hoffmann.
 * You can contact me at: ralf.hoffmann@epost.de
 *   or http://www.boomerangsworld.de/worker
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* $Id: worker_locale.cc,v 1.154 2004/07/04 20:05:25 ralf Exp $ */

#include "worker_locale.h"
#include "wconfig.h"
#include "worker.h"

#define CATENTRY 595
#define CATCOMENTRY 46
#define CATFLAGENTRY 54

#define min(a,b) (((a)<(b))?(a):(b))

WorkerLocale catalog;

WorkerLocale::WorkerLocale()
{
  int i;

  catalog=new char*[CATENTRY];
  catalogcom=new char*[CATCOMENTRY];
  catalogflag=new char*[CATFLAGENTRY];
  for(i=0;i<CATENTRY;i++) {
    catalog[i] = NULL;
  }
  for(i=0;i<CATCOMENTRY;i++) {
    catalogcom[i] = NULL;
  }
  for(i=0;i<CATFLAGENTRY;i++) {
    catalogflag[i] = NULL;
  }
  initBuiltinLang();
}

void WorkerLocale::initBuiltinLang()
{
  freeLanguage();

  catalog[0]=dupstring( "Worker Configuration" );
  catalog[1]=dupstring( "Global settings" );
  catalog[2]=dupstring( "Colors" );
  catalog[3]=dupstring( "Startup settings" );
  catalog[4]=dupstring( "Button settings" );
  catalog[5]=dupstring( "Path settings" );
  catalog[6]=dupstring( "Filetypes" );
  catalog[7]=dupstring( "Save" );
  catalog[8]=dupstring( "Cancel" );
  catalog[9]=dupstring( "Select Language:" );
  catalog[10]=dupstring( "english (builtin)" );
  catalog[11]=dupstring( "Okay" );
  catalog[12]=dupstring( "Welcome to Worker" );
  catalog[13]=dupstring( "Bytes" );
  catalog[14]=dupstring( "Color Count:" );
  catalog[15]=dupstring( "Palette" );
  catalog[16]=dupstring( "Filelister-Settings" );
  catalog[17]=dupstring( "Nr. of Rows for Buttons:" );
  catalog[18]=dupstring( "Nr. of Columns for Buttons:" );
  catalog[19]=dupstring( "Left ListView" );
  catalog[20]=dupstring( "Right ListView" );
  catalog[21]=dupstring( "Horizontal Scroller:" );
  catalog[22]=dupstring( "top:" );
  catalog[23]=dupstring( "Height:" );
  catalog[24]=dupstring( "Vertical Scroller:" );
  catalog[25]=dupstring( "left:" );
  catalog[26]=dupstring( "Width:" );
  catalog[27]=dupstring( "Palette-Entry:" );
  catalog[28]=dupstring( "Red:" );
  catalog[29]=dupstring( "Green:" );
  catalog[30]=dupstring( "Blue:" );
  catalog[31]=dupstring( "Statusbar" );
  catalog[32]=dupstring( "Foreground" );
  catalog[33]=dupstring( "Background" );
  catalog[34]=dupstring( "Selected ListView-Bar" );
  catalog[35]=dupstring( "Unselected ListView-Bar" );
  catalog[36]=dupstring( "unselected dir" );
  catalog[37]=dupstring( "selected dir" );
  catalog[38]=dupstring( "unselected file" );
  catalog[39]=dupstring( "selected file" );
  catalog[40]=dupstring( "Cant' save the config to %s!|Please check the worker installation!" );
  catalog[41]=dupstring( "Retry" );
  catalog[42]=dupstring( "A button named %s already uses this shortcut!|Click Okay to remove the reference to this shortcut|from the button and use it here instead" );
  catalog[43]=dupstring( "clockbar" );
  catalog[44]=dupstring( "Requester" );
  catalog[45]=dupstring( "Choose Color:" );
  catalog[46]=dupstring( "left Startup-Path:" );
  catalog[47]=dupstring( "right Startup-Path:" );
  catalog[48]=dupstring( "Copy Button" );
  catalog[49]=dupstring( "Swap Button" );
  catalog[50]=dupstring( "Delete Button" );
  catalog[51]=dupstring( "left Mousebutton" );
  catalog[52]=dupstring( "right Mousebutton" );
  catalog[53]=dupstring( "Choose Button to edit or Choose Action" );
  catalog[54]=dupstring( "Select Button to copy (or press ESC to cancel)" );
  catalog[55]=dupstring( "Select Destination-Button (will be overwrited) (or press ESC to cancel)" );
  catalog[56]=dupstring( "Select first Button to swap (or press ESC to cancel)" );
  catalog[57]=dupstring( "Select second Button to swap (or press ESC to cancel)" );
  catalog[58]=dupstring( "Select Button to delete (or press ESC to cancel)" );
  catalog[59]=dupstring( "Edit Button" );
  catalog[60]=dupstring( "Button Title:" );
  catalog[61]=dupstring( "Choose Shortcut" );
  catalog[62]=dupstring( "Delete Shortcut" );
  catalog[63]=dupstring( "A Path named %s already uses this shortcut!|Click Okay to remove the reference to this shortcut|from the path and use it here instead" );
  catalog[64]=dupstring( "Flags" );
  catalog[65]=dupstring( "A Hotkey named %s already uses this shortcut!|Click Okay to remove the reference to this shortcut|from the hotkey and use it here instead" );
  catalog[66]=dupstring( "Please press the key for the shortcut!" );
  catalog[67]=dupstring( "The destination directory %s doesn't exists!" );
  catalog[68]=dupstring( "Bank-Nr.:" );
  catalog[69]=dupstring( "next bank" );
  catalog[70]=dupstring( "prev. bank" );
  catalog[71]=dupstring( "new bank" );
  catalog[72]=dupstring( "delete bank" );
  catalog[73]=dupstring( "Copy path" );
  catalog[74]=dupstring( "Swap path" );
  catalog[75]=dupstring( "Delete path" );
  catalog[76]=dupstring( "Choose path to edit or one of the action-Buttons" );
  catalog[77]=dupstring( "Select path to copy (or press ESC to cancel)" );
  catalog[78]=dupstring( "Select Destination-path (will be overwrited) (or press ESC to cancel)" );
  catalog[79]=dupstring( "Select first path to swap (or press ESC to cancel)" );
  catalog[80]=dupstring( "Select second path to swap (or press ESC to cancel)" );
  catalog[81]=dupstring( "Select path to delete (or press ESC to cancel)" );
  catalog[82]=dupstring( "Edit Path" );
  catalog[83]=dupstring( "Path title:" );
  catalog[84]=dupstring( "Enter path:" );
  catalog[85]=dupstring( "New type" );
  catalog[86]=dupstring( "Duplicate type" );
  catalog[87]=dupstring( "Delete type" );
  catalog[88]=dupstring( "Edit type" );
  catalog[89]=dupstring( "Name:" );
  catalog[90]=dupstring( "Average rate:" );
  catalog[91]=dupstring( "Hotkeys" );
  catalog[92]=dupstring( "Hotkey-name:" );
  catalog[93]=dupstring( "Pattern:" );
  catalog[94]=dupstring( "Use Pattern" );
  catalog[95]=dupstring( "Filecontent" );
  catalog[96]=dupstring( "Use filecontent" );
  catalog[97]=dupstring( "Byte" );
  catalog[98]=dupstring( "Edit Byte" );
  catalog[99]=dupstring( "Clear Byte" );
  catalog[100]=dupstring( "Automatic creation" );
  catalog[101]=dupstring( "Edit filecontent" );
  catalog[102]=dupstring( "Enter code or press key" );
  catalog[103]=dupstring( "File" );
  catalog[104]=dupstring( "" );
  catalog[105]=dupstring( "Free RAM" );
  catalog[106]=dupstring( "Free Swap" );
  catalog[107]=dupstring( "Files" );
  catalog[108]=dupstring( "Dirs" );
  catalog[109]=dupstring( "Dir" );
  catalog[110]=dupstring( "Set to default viewer" );
  catalog[111]=dupstring( "" );
  catalog[112]=dupstring( "Choose the mode to toggle:" );
  catalog[113]=dupstring( "Error while copying %s|Source and destination is the same, skipping!" );
  catalog[114]=dupstring( "Quitting Worker" );
  catalog[115]=dupstring( "Do you really wanna quit Worker ?" );
  catalog[116]=dupstring( "Copy file %s" );
  catalog[117]=dupstring( "to %s" );
  catalog[118]=dupstring( "files to copy:" );
  catalog[119]=dupstring( "dirs to copy:" );
  catalog[120]=dupstring( "bytes copied" );
  catalog[121]=dupstring( "Remaining time:" );
  catalog[122]=dupstring( "Creating Database for copy-process" );
  catalog[123]=dupstring( "Worker Request" );
  catalog[124]=dupstring( "Worker Message" );
  catalog[125]=dupstring( "Worker Warning" );
  catalog[126]=dupstring( "Can't create the directory %s|All subfiles and subdirs are ignored" );
  catalog[127]=dupstring( "Can't create the directory %s!" );
  catalog[128]=dupstring( "Show free disk space" );
  catalog[129]=dupstring( "Updatetime:" );
  catalog[130]=dupstring( "Display of Ownerstring:" );
  catalog[131]=dupstring( "Owner @ group" );
  catalog[132]=dupstring( "Owner.group" );
  catalog[133]=dupstring( "Filter action:" );
  catalog[134]=dupstring( "Terminal program (with %s for file to execute in the term):" );
  catalog[135]=dupstring( "Overwrite all" );
  catalog[136]=dupstring( "Overwrite none" );
  catalog[137]=dupstring( "| Targetsize: %s| Sourcesize: %s|| Targettime: %s| Sourcetime: %s" );
  catalog[138]=dupstring( "Failed to remove the file %s|I will skip this file!" );
  catalog[139]=dupstring( "Failed to remove the destination file|The file %s is probably incomplete!" );
  catalog[140]=dupstring( "Creating Database for deleting" );
  catalog[141]=dupstring( "Deleting %s" );
  catalog[142]=dupstring( "remaining files:" );
  catalog[143]=dupstring( "remaining dirs:" );
  catalog[144]=dupstring( "Change dirs not to check" );
  catalog[145]=dupstring( "Do you really want to delete %ld files and %ld dirs recursive?" );
  catalog[146]=dupstring( "The dir %s is not empty|Delete it recursively?" );
  catalog[147]=dupstring( "Can't remove the directory %s!" );
  catalog[148]=dupstring( "Enter new name for %s:" );
  catalog[149]=dupstring( "Rename" );
  catalog[150]=dupstring( "Preserve attributes" );
  catalog[151]=dupstring( "Error while renaming!" );
  catalog[152]=dupstring( "Enter name for directory:" );
  catalog[153]=dupstring( "Delete active entry when no other are selected" );
  catalog[154]=dupstring( "New Hotkey" );
  catalog[155]=dupstring( "Duplicate Hotkey" );
  catalog[156]=dupstring( "Delete Hotkey" );
  catalog[157]=dupstring( "Edit Hotkey" );
  catalog[158]=dupstring( "Sortmode" );
  catalog[159]=dupstring( "Filter" );
  catalog[160]=dupstring( "Name-Sort" );
  catalog[161]=dupstring( "Size-Sort" );
  catalog[162]=dupstring( "Access-Time" );
  catalog[163]=dupstring( "Modification-Time" );
  catalog[164]=dupstring( "Change-Time" );
  catalog[165]=dupstring( "Reverse Sortorder" );
  catalog[166]=dupstring( "Listingmode" );
  catalog[167]=dupstring( "New Filter" );
  catalog[168]=dupstring( "Edit Filter(s)" );
  catalog[169]=dupstring( "Remove selected Filter(s)" );
  catalog[170]=dupstring( "include" );
  catalog[171]=dupstring( "exclude" );
  catalog[172]=dupstring( "Edit Filter" );
  catalog[173]=dupstring( "normal Filelister" );
  catalog[174]=dupstring( "show image mode" );
  catalog[175]=dupstring( "information mode" );
  catalog[176]=dupstring( "Name" );
  catalog[177]=dupstring( "Size" );
  catalog[178]=dupstring( "Type" );
  catalog[179]=dupstring( "Destination" );
  catalog[180]=dupstring( "Permissions" );
  catalog[181]=dupstring( "Add dir" );
  catalog[182]=dupstring( "Edit dir" );
  catalog[183]=dupstring( "Remove dir from list" );
  catalog[184]=dupstring( "Owner" );
  catalog[185]=dupstring( "Position" );
  catalog[186]=dupstring( "real position" );
  catalog[187]=dupstring( "Free space" );
  catalog[188]=dupstring( "of" );
  catalog[189]=dupstring( "No informations available" );
  catalog[190]=dupstring( "There is already a dir named %s" );
  catalog[191]=dupstring( "Include filter" );
  catalog[192]=dupstring( "Exclude filter" );
  catalog[193]=dupstring( "Unset filter" );
  catalog[194]=dupstring( "Unset all filters" );
  catalog[195]=dupstring( "The string is not valid!|Leave it empty or enter a string which contains one \"%s\"|  The filename of the script the terminal should run is inserted there!" );
  catalog[196]=dupstring( "Set to default" );
  catalog[197]=dupstring( "" );
  catalog[198]=dupstring( "Can't open destination file %s !" );
  catalog[199]=dupstring( "Enter dir to ignore for filetype-checking:" );
  catalog[200]=dupstring( "Enter text:" );
  catalog[201]=dupstring( "Press RETURN to continue!" );
  catalog[202]=dupstring( "" );
  catalog[203]=dupstring( "Can't get information about %s!|This file (or directory) will not be visible!" );
  catalog[204]=dupstring( "Font requester" );
  catalog[205]=dupstring( "The symlink %s couldn't be created!" );
  catalog[206]=dupstring( "Enter the destination of the symlink %s:" );
  catalog[207]=dupstring( "Enter the name of the link|which will point to %s:" );
  catalog[208]=dupstring( "About Worker" );
  catalog[209]=dupstring( "Font" );
  catalog[210]=dupstring( "" );
  catalog[211]=dupstring( "" );
  catalog[212]=dupstring( "Enter destination directory:" );
  catalog[213]=dupstring( "Permissions for %s:" );
  catalog[214]=dupstring( "Owner:" );
  catalog[215]=dupstring( "Group:" );
  catalog[216]=dupstring( "Other:" );
  catalog[217]=dupstring( "Special:" );
  catalog[218]=dupstring( "Read" );
  catalog[219]=dupstring( "Write" );
  catalog[220]=dupstring( "Execute" );
  catalog[221]=dupstring( "Set UID" );
  catalog[222]=dupstring( "Set GID" );
  catalog[223]=dupstring( "Sticky" );
  catalog[224]=dupstring( "Ok to all" );
  catalog[225]=dupstring( "Skip" );
  catalog[226]=dupstring( "Can't change permissions on %s!" );
  catalog[227]=dupstring( "Action-mode:" );
  catalog[228]=dupstring( "basic (action is used once)" );
  catalog[229]=dupstring( "extended (action can used until ESC or reclick on the action-button)" );
  catalog[230]=dupstring( "Enter new name" );
  catalog[231]=dupstring( "Load" );
  catalog[232]=dupstring( "Save as" );
  catalog[233]=dupstring( "Number of Directory-Buffers:" );
  catalog[234]=dupstring( "This will affect first after saving!" );
  catalog[235]=dupstring( "Display-properties" );
  catalog[236]=dupstring( "Up" );
  catalog[237]=dupstring( "Down" );
  catalog[238]=dupstring( "used options" );
  catalog[239]=dupstring( "Remove >>" );
  catalog[240]=dupstring( "<< Add" );
  catalog[241]=dupstring( "Global used Font" );
  catalog[242]=dupstring( "Font for Action- and Path-Buttons" );
  catalog[243]=dupstring( "Font for left listview" );
  catalog[244]=dupstring( "Font for right listview" );
  catalog[245]=dupstring( "Commands" );
  catalog[246]=dupstring( "Add Command" );
  catalog[247]=dupstring( "Remove Command" );
  catalog[248]=dupstring( "Configure" );
  catalog[249]=dupstring( "Choose Command" );
  catalog[250]=dupstring( "Actions" );
  catalog[251]=dupstring( "Drag'n'Drop-Action" );
  catalog[252]=dupstring( "DoubleClick-Action" );
  catalog[253]=dupstring( "Show-Action" );
  catalog[254]=dupstring( "RawShow-Action" );
  catalog[255]=dupstring( "User0-Action" );
  catalog[256]=dupstring( "User1-Action" );
  catalog[257]=dupstring( "User2-Action" );
  catalog[258]=dupstring( "User3-Action" );
  catalog[259]=dupstring( "User4-Action" );
  catalog[260]=dupstring( "User5-Action" );
  catalog[261]=dupstring( "User6-Action" );
  catalog[262]=dupstring( "User7-Action" );
  catalog[263]=dupstring( "User8-Action" );
  catalog[264]=dupstring( "User9-Action" );
  catalog[265]=dupstring( "Select file" );
  catalog[266]=dupstring( "Select the file of the filetype you want create:" );
  catalog[267]=dupstring( "Please select three existing files as source|for automatic creation!" );
  catalog[268]=dupstring( "Select entries" );
  catalog[269]=dupstring( "Deselect entries" );
  catalog[270]=dupstring( "Enter the pattern the matching entries will be selected for:" );
  catalog[271]=dupstring( "Enter the pattern the matching entries will be deselected for:" );
  catalog[272]=dupstring( "Want to handle dirs instead of files? Enter \"/\" as first char!" );
  catalog[273]=dupstring( "Use this dir" );
  catalog[274]=dupstring( "Delete link" );
  catalog[275]=dupstring( "There is already a symlink named %s, which points to a dir|You can use it so the destination dir is used|or delete the link to create a real directory" );
  catalog[276]=dupstring( "Failed to remove this file|Please enter new name!" );
  catalog[277]=dupstring( "Delete file" );
  catalog[278]=dupstring( "There is already a link named %s" );
  catalog[279]=dupstring( "There is already a file named %s" );
  catalog[280]=dupstring( "Overwrite" );
  catalog[281]=dupstring( "Failed to open the file %s" );
  catalog[282]=dupstring( "Can't overwrite the file %s|Shall I try to delete it?" );
  catalog[283]=dupstring( "" );
  catalog[284]=dupstring( "copied files" );
  catalog[285]=dupstring( "copied dirs" );
  catalog[286]=dupstring( "Failed to remove the file %s!" );
  catalog[287]=dupstring( "Delete all" );
  catalog[288]=dupstring( "Delete no nonempty dirs" );
  catalog[289]=dupstring( "The dir %s is not completely deleted!" );
  catalog[290]=dupstring( "Enter dir you want to cd to:" );
  catalog[291]=dupstring( "Can't remove %s!" );
  catalog[292]=dupstring( "No options available" );
  catalog[293]=dupstring( "Configure \"%s\"" );
  catalog[294]=dupstring( "Request these flags" );
  catalog[295]=dupstring( "do changes on files" );
  catalog[296]=dupstring( "do changes on dirs" );
  catalog[297]=dupstring( "do recursive" );
  catalog[298]=dupstring( "Follow symlinks" );
  catalog[299]=dupstring( "Move" );
  catalog[300]=dupstring( "Rename" );
  catalog[301]=dupstring( "Same dir" );
  catalog[302]=dupstring( "Request destination" );
  catalog[303]=dupstring( "Overwrite-mode" );
  catalog[304]=dupstring( "request" );
  catalog[305]=dupstring( "always" );
  catalog[306]=dupstring( "never" );
  catalog[307]=dupstring( "copy-mode" );
  catalog[308]=dupstring( "normal" );
  catalog[309]=dupstring( "fast" );
  catalog[310]=dupstring( "" );
  catalog[311]=dupstring( "" );
  catalog[312]=dupstring( "value not allowed|Please change it or leave it blank" );
  catalog[313]=dupstring( "Change" );
  catalog[314]=dupstring( "Blank" );
  catalog[315]=dupstring( "Create symlink in same directory" );
  catalog[316]=dupstring( "" );
  catalog[317]=dupstring( "Action" );
  catalog[318]=dupstring( "enter active entry" );
  catalog[319]=dupstring( "enter active entry on other side" );
  catalog[320]=dupstring( "special dir" );
  catalog[321]=dupstring( "request directory" );
  catalog[322]=dupstring( "special dir:" );
  catalog[323]=dupstring( "Side to edit" );
  catalog[324]=dupstring( "current side" );
  catalog[325]=dupstring( "other side" );
  catalog[326]=dupstring( "left side" );
  catalog[327]=dupstring( "right side" );
  catalog[328]=dupstring( "" );
  catalog[329]=dupstring( "Seperate each entry" );
  catalog[330]=dupstring( "Recursive" );
  catalog[331]=dupstring( "Startmode" );
  catalog[332]=dupstring( "normal mode" );
  catalog[333]=dupstring( "in terminal" );
  catalog[334]=dupstring( "in terminal and wait for key" );
  catalog[335]=dupstring( "show output" );
  catalog[336]=dupstring( "program:" );
  catalog[337]=dupstring( "program for viewing output:" );
  catalog[338]=dupstring( "Select flag:" );
  catalog[339]=dupstring( "Side to reload" );
  catalog[340]=dupstring( "Direction" );
  catalog[341]=dupstring( "left" );
  catalog[342]=dupstring( "right" );
  catalog[343]=dupstring( "global program" );
  catalog[344]=dupstring( "Not yet checked" );
  catalog[345]=dupstring( "Unknown filetype" );
  catalog[346]=dupstring( "NoSelect-type" );
  catalog[347]=dupstring( "Error" );
  catalog[348]=dupstring( "Side:" );
  catalog[349]=dupstring( "Enter default filter:" );
  catalog[350]=dupstring( "Worker quit mode" );
  catalog[351]=dupstring( "request" );
  catalog[352]=dupstring( "quick" );
  catalog[353]=dupstring( "Dir positions:" );
  catalog[354]=dupstring( "Dirs first" );
  catalog[355]=dupstring( "Dirs last" );
  catalog[356]=dupstring( "Dirs mixed" );
  catalog[357]=dupstring( "Show hidden entries" );
  catalog[358]=dupstring( "Don't use" );
  catalog[359]=dupstring( "Error while writing %s !" );
  catalog[360]=dupstring( "toggle Hidden-flag" );
  catalog[361]=dupstring( "don't show hidden files" );
  catalog[362]=dupstring( "show hidden files" );
  catalog[363]=dupstring( "I changed the behaviour of \"Separate Each Entry\" in \"own command\"|Read the doc for details" );
  catalog[364]=dupstring( "Importing old config..." );
  catalog[365]=dupstring( "Sorry, there is no such font!" );
  catalog[366]=dupstring( "Found old config, importing..." );
  catalog[367]=dupstring( "The file %s isn't a worker configfile!|Using default config" );
  catalog[368]=dupstring( "Clockbar settings" );
  catalog[369]=dupstring( "Clockbar mode:" );
  catalog[370]=dupstring( "Show current time and free ram/swap (on linux)" );
  catalog[371]=dupstring( "Show current time" );
  catalog[372]=dupstring( "Show worker version" );
  catalog[373]=dupstring( "Show output of an extern program" );
  catalog[374]=dupstring( "program:" );
  catalog[375]=dupstring( "unselected active dir" );
  catalog[376]=dupstring( "selected active dir" );
  catalog[377]=dupstring( "unselected active file" );
  catalog[378]=dupstring( "selected active file" );
  catalog[379]=dupstring( "listview background" );
  catalog[380]=dupstring( "Select font:" );
  catalog[381]=dupstring( "Enter own font (with X name)" );
  catalog[382]=dupstring( "Font example" );
  catalog[383]=dupstring( "X font name:" );
  catalog[384]=dupstring( "The configuration file is from a newer Worker version and cannot be loaded!|Please update atleast to version %d.%d.%d.|I will continue with the default config." );
  catalog[385]=dupstring( "Reset directory sizes" );
  catalog[386]=dupstring( "Use <DIR> for unknown dir sizes" );
  catalog[387]=dupstring( "Activate shortkey" );
  catalog[388]=dupstring( "Select shortkey:" );
  catalog[389]=dupstring( "Button:" );
  catalog[390]=dupstring( "Path:" );
  catalog[391]=dupstring( "Hotkey:" );
  catalog[392]=dupstring( "Activate" );
  catalog[393]=dupstring( "The destination file %s is incomplete!|Keep this file or delete it?" );
  catalog[394]=dupstring( "Keep" );
  catalog[395]=dupstring( "Delete" );
  catalog[396]=dupstring( "Import/Export" );
  catalog[397]=dupstring( "Import" );
  catalog[398]=dupstring( "Export" );
  catalog[399]=dupstring( "Changes made here only affect the exported config|not your real configuration!" );
  catalog[400]=dupstring( "File %s isn't a valid worker export file!" );
  catalog[401]=dupstring( "configure Buttons to export" );
  catalog[402]=dupstring( "configure Hotkeys to export" );
  catalog[403]=dupstring( "configure Filetypes to export" );
  catalog[404]=dupstring( "Filename:" );
  catalog[405]=dupstring( "Choose" );
  catalog[406]=dupstring( "Please select or enter file to export to:" );
  catalog[407]=dupstring( "Please mark which elements you want to export|and enter the filename!" );
  catalog[408]=dupstring( "%s is a dir, please enter an other name" );
  catalog[409]=dupstring( "%s already exists, overwrite?" );
  catalog[410]=dupstring( "Export to %s finished." );
  catalog[411]=dupstring( "Can't open %s for writing, please select an other file" );
  catalog[412]=dupstring( "%s isn't a file!" );
  catalog[413]=dupstring( "Export file is from a newer worker version!|Update atleast to version %d.%d.%d to use it." );
  catalog[414]=dupstring( "The configuration contains %d button bank(s), %d hotkey(s) and %d filetype(s).|You can now change these parts before importing them." );
  catalog[415]=dupstring( "Please enter the filename to import from" );
  catalog[416]=dupstring( "You can change the import configuration before|the selected parts will be imported." );
  catalog[417]=dupstring( "Please mark which parts you want to import." );
  catalog[418]=dupstring( "There are no elements in the selected configuration!" );
  catalog[419]=dupstring( "The new button %s uses the same shortkey as the button %s!" );
  catalog[420]=dupstring( "The new hotkey %s uses the same shortkey as the button %s!" );
  catalog[421]=dupstring( "The new button %s uses the same shortkey as the hotkey %s!" );
  catalog[422]=dupstring( "The new hotkey %s uses the same shortkey as the hotkey %s!" );
  catalog[423]=dupstring( "The new button %s uses the same shortkey as the path %s!" );
  catalog[424]=dupstring( "The new hotkey %s uses the same shortkey as the path %s!" );
  catalog[425]=dupstring( "Leave shortkey at original element" );
  catalog[426]=dupstring( "Use shortkey for new element" );
  catalog[427]=dupstring( "Use original" );
  catalog[428]=dupstring( "Use new" );
  catalog[429]=dupstring( "The importconfiguration contains the special filetype %s|which would overwrite the original type %s!|Which one do you want to use?" );
  catalog[430]=dupstring( "Import successful" );
  catalog[431]=dupstring( "Never use shortkey for new element" );
  catalog[432]=dupstring( "Filetype-Sort" );
  catalog[433]=dupstring( "Owner-Sort" );
  catalog[434]=dupstring( "Keep filetypes" );
  catalog[435]=dupstring( "Run in background" );
  catalog[436]=dupstring( "Yesterday" );
  catalog[437]=dupstring( "Today" );
  catalog[438]=dupstring( "Tomorrow" );
  catalog[439]=dupstring( "Date/Time-Settings" );
  catalog[440]=dupstring( "Date:" );
  catalog[441]=dupstring( "Own format (strftime style):" );
  catalog[442]=dupstring( "Name substitution (Today, Yesterday, ...)" );
  catalog[443]=dupstring( "own format" );
  catalog[444]=dupstring( "Time:" );
  catalog[445]=dupstring( "Date before time" );
  catalog[446]=dupstring( "Can't change owner for %s!|Permission denied!" );
  catalog[447]=dupstring( "Error while changing owner for %s!" );
  catalog[448]=dupstring( "Owner for %s:" );
  catalog[449]=dupstring( "Shortkeys:" );
  catalog[450]=dupstring( "Add shortkey" );
  catalog[451]=dupstring( "Remove shortkey" );
  catalog[452]=dupstring( "Add normal or double shortkey?" );
  catalog[453]=dupstring( "Normal" );
  catalog[454]=dupstring( "Double" );
  catalog[455]=dupstring( "Please press the first key for the shortcut!" );
  catalog[456]=dupstring( "Please press the second key for the shortcut!" );
  catalog[457]=dupstring( "This shortkey conflicts with a key used here!" );
  catalog[458]=dupstring( "Find" );
  catalog[459]=dupstring( "Label %s not found for if-statement at line %d!|Aborting" );
  catalog[460]=dupstring( "Error in if-statement at line %d!|Aborting" );
  catalog[461]=dupstring( "Script command:" );
  catalog[462]=dupstring( "nop" );
  catalog[463]=dupstring( "push" );
  catalog[464]=dupstring( "pop" );
  catalog[465]=dupstring( "label" );
  catalog[466]=dupstring( "if" );
  catalog[467]=dupstring( "end" );
  catalog[468]=dupstring( "Push a string on a stack" );
  catalog[469]=dupstring( "Push the output of the command" );
  catalog[470]=dupstring( "Stack number:" );
  catalog[471]=dupstring( "String:" );
  catalog[472]=dupstring( "Take a string from a stack" );
  catalog[473]=dupstring( "Cannot continue if-parsing because following command writes something to stderr|and I take this as an error:|%s|Aborting..." );
  catalog[474]=dupstring( "Run in debug mode" );
  catalog[475]=dupstring( "Label:" );
  catalog[476]=dupstring( "This does nothing" );
  catalog[477]=dupstring( "This will immediately finish the execution of the commandlist" );
  catalog[478]=dupstring( "Jump to label when condition is true" );
  catalog[479]=dupstring( "Condition:" );
  catalog[480]=dupstring( "Cannot push the output of the following command because it writes something to stderr|and I take this as an error:|%s|Aborting..." );
  catalog[481]=dupstring( "Choose flag:|The flags beginning at {Rs} are only allowed|inside \"\" or in ?{}/${}!" );
  catalog[482]=dupstring( "You can choose flags with the requester by clicking at \"F\".|You can use parentheses if necessary, && means both sides have to be true, \\|\\| one of both.|\
use <, <=, ==, >=, >, != as usual; when both sides are strings (\"\" or ${}) they are compared as strings, otherwise with the|\
numerical value. So ( \"5\" > \"06\" ) is true while ( 5 > \"06\" ) is false!" );
  catalog[483]=dupstring( "Help" );
  catalog[484]=dupstring( "if-debug: Result of %s is %d" );
  catalog[485]=dupstring( "push-debug: pushing %s at stack %d" );
  catalog[486]=dupstring( "settings" );
  catalog[487]=dupstring( "Choose \"Recursive\" for collect all files recursive (for selected dirs)|  This can only be changed as the very first command!|Choose \"With quotes\" if you want filenames in quotes when replacing flags|\
  This can be changed by any time" );
  catalog[488]=dupstring( "change user window" );
  catalog[489]=dupstring( "Here you can change the window you can use to show some information to the user.|You can change the progress bar by any string which can contain flags and|you can also use the output\
 of this string for the progress.|The only limitation is that the resulting string can be transformed to a number between 0 and 100!|You can also change the text shown above the progress\
bar and this string can contain \\||for a new line (as many as you want). Of course this string can contain any valid flags and|you can also use the output instead." );
  catalog[490]=dupstring( "Change window visibility" );
  catalog[491]=dupstring( "Open window" );
  catalog[492]=dupstring( "Close window" );
  catalog[493]=dupstring( "Change progress bar" );
  catalog[494]=dupstring( "Progress:" );
  catalog[495]=dupstring( "Use the output for the progress" );
  catalog[496]=dupstring( "Change text" );
  catalog[497]=dupstring( "Text:" );
  catalog[498]=dupstring( "Use the output for the text" );
  catalog[499]=dupstring( "Worker script window" );
  catalog[500]=dupstring( "Copy dir %s" );
  catalog[501]=dupstring( "Ignore case" );
  catalog[502]=dupstring( "Use regular expression" );
  catalog[503]=dupstring( "Command execution stopped by USR1 signal!" );  // request text
  catalog[504]=dupstring( "The following command writes something to stderr:|%s|I don't update the user window" );
  catalog[505]=dupstring( "" );
  catalog[506]=dupstring( "File handled with %s" );
  catalog[507]=dupstring( "File handled as normal file" );
  catalog[508]=dupstring( "Show complete license" );
  catalog[509]=dupstring( "Worker license" );
  catalog[510]=dupstring( "The configuration has changed!|Shall I reload it?" );
  catalog[511]=dupstring( "Reload" );
  catalog[512]=dupstring( "Don't reload" );
  catalog[513]=dupstring( "Also use dirs for flag-replacing (when collecting recursive)" );
  catalog[514]=dupstring( "Label %s not found for goto-statement at line %d!|Aborting" );
  catalog[515]=dupstring( "goto" );
  catalog[516]=dupstring( "Can't copy|  %s|to|  %s|because I can't remove destination!|Error:%s" );
  catalog[517]=dupstring( "Can't copy|  %s|to|  %s|Error:%s" );
  catalog[518]=dupstring( "Can't copy|  %s|to|  %s|Can't get information about source!|Error:%s" );
  catalog[519]=dupstring( "Can't copy|  %s|to|  %s|Can't get symlink destination!|Error:%s" );
  catalog[520]=dupstring( "Can't copy|  %s|because it's a special file and I can't handle it yet!" );
  catalog[521]=dupstring( "Enter the image viewing program|Now the string is just the program name to use!|\
This program has to accept 7 arguments: the first 4 are: x, y, width height.|The 5th is the hex-number of the window.|\
Then the filename follows and the last argument is the the background color in the X11-format \"rgb:rr/gg/bb\"." );
  catalog[522]=dupstring( "Enter command and additional arguments:|This string will be executed in a shell but not all shell features \
are allowed!|You can use \"&&\", \"\\|\\|\", \"\\|\", \";\" and \"&\"  (all as a single word) just as in a shell and redirections|\
can also be used (also as single word, so e.g. 2>/dev/null have to be 2> /dev/null), but|\
all other stuff is not allowed!|\
You have to protect special characters in filenames with a backslash or quote them correctly.|\
The default value here is the active entry and it's already correctly protected!" );
  catalog[523]=dupstring( "Directory cache list" );
  catalog[524]=dupstring( "Select or enter a directory:" );
  catalog[525]=dupstring( "Error while reading from \"%s\"|Error:%s" );
  catalog[526]=dupstring( "Error while writing to \"%s\"|Error:%s" );
  catalog[527]=dupstring( "octal:" );
  catalog[528]=dupstring( "Move was canceled but some files were correctly copied!|Shall I delete these files from the source?" );
  catalog[529]=dupstring( " - %s %s/%s %s free" );
  catalog[530]=dupstring( "The following files/dirs in the directory %s couldn't be copied|because I didn't get information about them:" );
  catalog[531]=dupstring( "Can't get information about existing file|%s|because of this error:|%s" );
  catalog[532]=dupstring( "Can't read directory|%s|because of this error:|%s" );
  catalog[533]=dupstring( "Create relative symlink" );
  catalog[534]=dupstring( "Select program" );
  catalog[535]=dupstring( "Select on of the shown programs, make sure you have|the corresponding program!" );
  catalog[536]=dupstring( "I didn't restore the SUID/SGUID bit for the file|%s|because chown to old owner failed (probably you are not|the owner or not root)." );
  catalog[537]=dupstring( "Ignore further warnings" );
  catalog[538]=dupstring( "You changed the configuration!|Do you really want to discard your changes?" );
  catalog[539]=dupstring( "Error while reading configuration!|The following error occurred in line %d:|%s|I will continue with the partly read config." );
  catalog[540]=dupstring( "configure Buttons to import" );
  catalog[541]=dupstring( "configure Hotkeys to import" );
  catalog[542]=dupstring( "configure Filetypes to import" );
  catalog[543]=dupstring( "Do you really want to abort?" );
  catalog[544]=dupstring( "Continue with copying" );
  catalog[545]=dupstring( "There is no space left for file %s|in directory %s !" );
  catalog[546]=dupstring( "The external program failed with following error:" );
  catalog[547]=dupstring( "Waiting for program (stop waiting with Escape or middle click)" );
  catalog[548]=dupstring( "Inode" );
  catalog[549]=dupstring( "Hard links" );
  catalog[550]=dupstring( "Blocks" );
  catalog[551]=dupstring( "%s blocks" );
  catalog[552]=dupstring( "Inode sort" );
  catalog[553]=dupstring( "Hard links sort" );
  catalog[554]=dupstring( "Show header line:" );
  catalog[555]=dupstring( "listview header" );
  catalog[556]=dupstring( "Statebar" );
  catalog[557]=dupstring( "Clockbar" );
  catalog[558]=dupstring( "Buttons" );
  catalog[559]=dupstring( "ListViews" );
  catalog[560]=dupstring( "Buttons,ListView,ListView" );
  catalog[561]=dupstring( "ListView,Buttons,ListView" );
  catalog[562]=dupstring( "ListView,ListView,Buttons" );
  catalog[563]=dupstring( "Buttons,ListViews" );
  catalog[564]=dupstring( "Listviews,Buttons" );
  catalog[565]=dupstring( "Select Button and Listview orientation:" );
  catalog[566]=dupstring( "Select the positions of the elements;|Select two elements with\
 a position to swap,|doubleclick to remove position:" );
  catalog[567]=dupstring( "Buttons vertical" );
  catalog[568]=dupstring( "ListViews vertical" );
  catalog[569]=dupstring( "Layout configuration" );
  catalog[570]=dupstring( "Match full filename" );
  catalog[571]=dupstring( "Swap next" );
  catalog[572]=dupstring( "Swap prev" );
  catalog[573]=dupstring( "extended test:" );
  catalog[574]=dupstring( "use extended test" );
  catalog[575]=dupstring( "Pattern" );
  catalog[576]=dupstring( "Extended Test" );
  catalog[577]=dupstring( "Without using regular expressions, you can use the common shell \
wildcards:| * for matching any string| ? for matching a single character|\
 [...] for matching a character class|See the shell manual for more information.||\
You can also use basic regular expressions, some examples follow:| .* for matching any string|\
 \\+ matches one or more occurences| \\? matches zero or one occurence|\
 ^ matches the beginning of the line| $ matches the end| \\( and \\) can be used for sub\
expressions| \\\\\\| matches one of the subexpressions|For more information see the regular \
expression manual (man 7 regex)" );
  catalog[578]=dupstring( "Choose flag:" );
  catalog[579]=dupstring( "true if entry is a regular file" );
  catalog[580]=dupstring( "true if entry is a socket" );
  catalog[581]=dupstring( "true if entry is a FIFO (pipe)" );
  catalog[582]=dupstring( "true if entry is a symlink" );
  catalog[583]=dupstring( "filesize" );
  catalog[584]=dupstring( "permission (numerical) bitwise-and'd with mask" );
  catalog[585]=dupstring( "lowers string" );
  catalog[586]=dupstring( "uppers string" );
  catalog[587]=dupstring( "replaces with file content from start to optional end offset" );
  catalog[588]=dupstring( "replaces with file content read as number from start to optional \
end offset" );
  catalog[589]=dupstring( "filename" );
  catalog[590]=dupstring( "full filename" );
  catalog[591]=dupstring( "filename (only valid inside strings)" );
  catalog[592]=dupstring( "full filename (only valid inside strings)" );
  catalog[593]=dupstring( "You can choose flags with the requester by clicking at the \"F\". Start \
the flag identifier|with a \"-\" if you don't want to quote the string (e.g. {-f}). The functions \
\"contentStr\"|and \"contentNum\" can be called without a second argument which will \
use only one character.|You \
can use parentheses if necessary, && means both sides have to be true, \\|\\| one of both.|\
use <, <=, ==, >=, >, != as usual and ~= for string comparison using regular|expressions; \
when both sides are strings (\"\" or ${}) they are compared as strings,|otherwise with the \
numerical value. So ( \"5\" > \"06\" ) is true while ( 5 > \"06\" ) is false!" );
  catalog[594]=dupstring( "Move file %s" );

//  catalog[]=dupstring( "" );
  
  catalogcom[0]=dupstring( "DragNDrop-Action" );
  catalogcom[1]=dupstring( "DoubleClick-Action" );
  catalogcom[2]=dupstring( "Show-Action" );
  catalogcom[3]=dupstring( "RawShow-Action" );
  catalogcom[4]=dupstring( "User-Action" );
  catalogcom[5]=dupstring( "One row up" );
  catalogcom[6]=dupstring( "One row down" );
  catalogcom[7]=dupstring( "Change hidden flag" );
  catalogcom[8]=dupstring( "Copy" );
  catalogcom[9]=dupstring( "First Entry" );
  catalogcom[10]=dupstring( "Last Entry" );
  catalogcom[11]=dupstring( "Page Up" );
  catalogcom[12]=dupstring( "Page Down" );
  catalogcom[13]=dupstring( "(De)Select active entry" );
  catalogcom[14]=dupstring( "Select all entries" );
  catalogcom[15]=dupstring( "Deselect all entries" );
  catalogcom[16]=dupstring( "invert selection" );
  catalogcom[17]=dupstring( "go to parent dir" );
  catalogcom[18]=dupstring( "go to dir" );
  catalogcom[19]=dupstring( "Change ListView settings" );
  catalogcom[20]=dupstring( "switch to other listview" );
  catalogcom[21]=dupstring( "pattern select" );
  catalogcom[22]=dupstring( "pattern unselect" );
  catalogcom[23]=dupstring( "path to other side" );
  catalogcom[24]=dupstring( "Quit worker" );
  catalogcom[25]=dupstring( "Delete" );
  catalogcom[26]=dupstring( "Reload" );
  catalogcom[27]=dupstring( "Make dir" );
  catalogcom[28]=dupstring( "own command" );
  catalogcom[29]=dupstring( "rename" );
  catalogcom[30]=dupstring( "dirsize" );
  catalogcom[31]=dupstring( "simulate doubleclick" );
  catalogcom[32]=dupstring( "start prog" );
  catalogcom[33]=dupstring( "search entry" );
  catalogcom[34]=dupstring( "edit path (in the text field)" );
  catalogcom[35]=dupstring( "scroll listview" );
  catalogcom[36]=dupstring( "create symlink" );
  catalogcom[37]=dupstring( "change symlink" );
  catalogcom[38]=dupstring( "change permissions" );
  catalogcom[39]=dupstring( "toggle listviewmode" );
  catalogcom[40]=dupstring( "set sortmode" );
  catalogcom[41]=dupstring( "set filter" );
  catalogcom[42]=dupstring( "activate shortkey from list" );
  catalogcom[43]=dupstring( "change owner" );
  catalogcom[44]=dupstring( "script" );
  catalogcom[45]=dupstring( "show directory cache" );
  
  catalogflag[0]=dupstring( "Stringrequester" );
  catalogflag[1]=dupstring( "path" );
  catalogflag[2]=dupstring( "other path" );
  catalogflag[3]=dupstring( "left path" );
  catalogflag[4]=dupstring( "right path" );
  catalogflag[5]=dupstring( "first selected entry without path" );
  catalogflag[6]=dupstring( "first selected entry with path" );
  catalogflag[7]=dupstring( "all selected entry without path" );
  catalogflag[8]=dupstring( "all selected entry with path" );
  catalogflag[9]=dupstring( "first selected entry without path (no extension)" );
  catalogflag[10]=dupstring( "first selected entry with path (no extension)" );
  catalogflag[11]=dupstring( "all selected entry without path (no extension)" );
  catalogflag[12]=dupstring( "all selected entry with path (no extension)" );
  catalogflag[13]=dupstring( "first selected entry without path (no unselect)" );
  catalogflag[14]=dupstring( "first selected entry with path (no unselect)" );
  catalogflag[15]=dupstring( "all selected entry without path (no unselect)" );
  catalogflag[16]=dupstring( "all selected entry with path (no unselect)" );
  catalogflag[17]=dupstring( "first selected entry without path (no unselect, no extension)" );
  catalogflag[18]=dupstring( "first selected entry with path (no unselect, no extension)" );
  catalogflag[19]=dupstring( "all selected entry without path (no unselect, no extension)" );
  catalogflag[20]=dupstring( "all selected entry with path (no unselect, no extension)" );
  catalogflag[21]=dupstring( "other side: first selected entry without path" );
  catalogflag[22]=dupstring( "other side: first selected entry with path" );
  catalogflag[23]=dupstring( "other side: all selected entry without path" );
  catalogflag[24]=dupstring( "other side: all selected entry with path" );
  catalogflag[25]=dupstring( "other side: first selected entry without path (no extension)" );
  catalogflag[26]=dupstring( "other side: first selected entry with path (no extension)" );
  catalogflag[27]=dupstring( "other side: all selected entry without path (no extension)" );
  catalogflag[28]=dupstring( "other side: all selected entry with path (no extension)" );
  catalogflag[29]=dupstring( "other side: first selected entry without path (no unselect)" );
  catalogflag[30]=dupstring( "other side: first selected entry with path (no unselect)" );
  catalogflag[31]=dupstring( "other side: all selected entry without path (no unselect)" );
  catalogflag[32]=dupstring( "other side: all selected entry with path (no unselect)" );
  catalogflag[33]=dupstring( "other side: first selected entry without path (no unselect, no extension)" );
  catalogflag[34]=dupstring( "other side: first selected entry with path (no unselect, no extension)" );
  catalogflag[35]=dupstring( "other side: all selected entry without path (no unselect, no extension)" );
  catalogflag[36]=dupstring( "other side: all selected entry with path (no unselect, no extension)" );
  catalogflag[37]=dupstring( "destination path (for DND)" );
  catalogflag[38]=dupstring( "remove top element of given stack (default 0)" );
  catalogflag[39]=dupstring( "get (not remove) top element of given stack (default 0)" );
  catalogflag[40]=dupstring( "true when stack is empty" );
  catalogflag[41]=dupstring( "size of stack" );
  catalogflag[42]=dupstring( "last error (0 means no error)" );
  catalogflag[43]=dupstring( "true when filelist is empty (no more {f})" );
  catalogflag[44]=dupstring( "always true" );
  catalogflag[45]=dupstring( "always false" );
  catalogflag[46]=dupstring( "string (flags from own command can be used)" );
  catalogflag[47]=dupstring( "replaces with returnvalue of the command inside the brace (flags can be used)" );
  catalogflag[48]=dupstring( "replaces with output (first line) of the command inside the brace (flags can be used)" );
  catalogflag[49]=dupstring( "replaces with the size of given stack (default 0)" );
  catalogflag[50]=dupstring( "replaces with value of the given env-variable" );
  catalogflag[51]=dupstring( "convert the expression inside the parentheses into a number" );
  catalogflag[52]=dupstring( "convert the expression inside the parentheses into a string" );
  catalogflag[53]=dupstring( "path to the \"scripts\" directory" );
}

WorkerLocale::~WorkerLocale()
{
  freeLanguage();
  delete [] catalog;
  delete [] catalogcom;
  delete [] catalogflag;
}

int WorkerLocale::openCatFile(Datei*file,const char *name,const char *ext)
{
  bool ok=false;
  int len;
  std::string mainstr;
  const char *home=wconfig->getHome();
  if ( Worker::getDataDir().length() > 0 ) {
    mainstr = Worker::getDataDir();
    mainstr += "/catalogs/";
    mainstr += name;
  #ifdef USEOWNCONFIGFILES
    mainstr += ".catalog2";
  #else
    mainstr += ".catalog";
  #endif
    mainstr += ext;
    if ( file->open( mainstr.c_str(), "r" ) == 0 ) ok = true;
  }
  if(ok==false) {
    len=strlen(home);
    if(len<1) return 1;
    mainstr = home;
    mainstr += "/catalogs/";
    mainstr += name;
  #ifdef USEOWNCONFIGFILES
    mainstr += ".catalog2";
  #else
    mainstr += ".catalog";
  #endif
    mainstr += ext;
    if ( file->open( mainstr.c_str(), "r" ) == 0 ) ok = true;
  }
  if(ok==true) return 0;
  return 1;
}

int WorkerLocale::loadLanguage(const char *name)
{
  freeLanguage();
  initBuiltinLang();
  Datei *file=new Datei();

  if(openCatFile(file,name,"")==0) {
    parse(file,0);
    file->close();

    if(openCatFile(file,name,".coms")==0) {
      parse(file,1);
      file->close();
    }

    if(openCatFile(file,name,".flags")==0) {
      parse(file,2);
      file->close();
    }
  } else debugmsg("selected language not available, using builtin!\n");
  delete file;
  return 0;
}

void WorkerLocale::parse(Datei *file,int cat)
{
  char *buffer=(char*)_allocsafe(128*1024);
  int mode,bufpos;
  int entrynr;
  int ch;
  char *tstr;

  mode=0;
  bufpos=0;
  entrynr=0;
  
  for(;;) {
    ch=file->getCharAsInt();
    if(ch==EOF) break;
    switch(mode) {
      case 1:
        if(ch=='\n') {
          mode=0;
          bufpos=0;
          entrynr=0;
        }
        break;
      case 2:
        // old style
        if(ch=='\n') {
          buffer[bufpos]=0;
          entrynr++;
          bufpos=0;
        } else {
          buffer[min(128*1024-1,bufpos)]=(char)ch;
          bufpos++;
        }
        break;
      case 3:
        if(ch=='\\') {
          mode=4;
        } else if((ch=='\n')||(ch=='#')) {
          buffer[bufpos]=0;
          if(strlen(buffer)>0) {
            // store buffer in entrynr
            tstr = dupstring( buffer );
            switch(cat) {
              case 0:
                // normal
                if(entrynr<CATENTRY) {
                  if ( catalog[entrynr] != NULL ) _freesafe( catalog[entrynr] );
                  catalog[entrynr]=tstr;
                } else _freesafe(tstr);
                break;
              case 1:
                // com
                if(entrynr<CATCOMENTRY) {
                  if ( catalogcom[entrynr] != NULL ) _freesafe( catalogcom[entrynr] );
                  catalogcom[entrynr]=tstr;
                } else _freesafe(tstr);
                break;
              case 2:
                // flag
                if(entrynr<CATFLAGENTRY) {
                  if ( catalogflag[entrynr] != NULL ) _freesafe( catalogflag[entrynr] );
                  catalogflag[entrynr]=tstr;
                } else _freesafe(tstr);
                break;
              default:
                _freesafe(tstr);
                break;
            }
          }
          if(ch=='#') mode=1;
          else {
            mode=0;
            bufpos=0;
            entrynr=0;
          }
        } else {
          buffer[min(128*1024-1,bufpos)]=(char)ch;
          bufpos++;
        }
        break;
      case 4:
        if(ch!='\n') {
          buffer[min(128*1024-1,bufpos)]=(char)ch;
          bufpos++;
        }
        mode=3;
        break;
      default:
        if(isdigit(ch)!=0) {
          buffer[min(128*1024-1,bufpos)]=(char)ch;
          bufpos++;
        } else if(ch=='#') {
          mode=1;
        } else if(ch==':') {
          buffer[bufpos]=0;
          entrynr=0;
          sscanf(buffer,"%d",&entrynr);
          mode=3;
          bufpos=0;
        } else if(ch=='\n') {
        } else {
          // old style
          //TODO: bessere Meldung
          printf("oldstyle-catalog-format not supported\n");
          mode=2;
          buffer[min(128*1024-1,bufpos)]=(char)ch;
          bufpos++;
          entrynr=0;
        }
        break;
    }
  }
  _freesafe(buffer);
}

void WorkerLocale::resetLanguage()
{
  freeLanguage();
  initBuiltinLang();
}

void WorkerLocale::freeLanguage()
{
  int i;
  for(i=0;i<CATENTRY;i++) {
    if ( catalog[i] != NULL ) _freesafe(catalog[i]);
    catalog[i] = NULL;
  }
  for(i=0;i<CATCOMENTRY;i++) {
    if ( catalogcom[i] != NULL ) _freesafe(catalogcom[i]);
    catalogcom[i] = NULL;
  }
  for(i=0;i<CATFLAGENTRY;i++) {
    if ( catalogflag[i] != NULL ) _freesafe(catalogflag[i]);
    catalogflag[i] = NULL;
  }
}

const char *WorkerLocale::getLocale(int index2)
{
  if((index2<0)||(index2>=CATENTRY)) return "?";
  if ( catalog[index2] == NULL ) return "?";
  return catalog[index2];
}

const char *WorkerLocale::getLocaleCom(int index2)
{
  if((index2<0)||(index2>=CATCOMENTRY)) return "?";
  if ( catalogcom[index2] == NULL ) return "?";
  return catalogcom[index2];
}

const char *WorkerLocale::getLocaleFlag(int index2)
{
  if((index2<0)||(index2>=CATFLAGENTRY)) return "?";
  if ( catalogflag[index2] == NULL ) return "?";
  return catalogflag[index2];
}

int WorkerLocale::getCatComEntry()
{
  return CATCOMENTRY;
}

